package com.tenlionsoft.aimz_k.viewmodel

import android.content.Context
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.viewModelScope
import com.atwa.filepicker.result.ImageMeta
import com.tenlionsoft.aimz_k.net.BaseApi
import com.tenlionsoft.baselib.base.BaseViewModel
import com.tenlionsoft.baselib.contacts.toFileBody
import com.tenlionsoft.baselib.net.ExParse
import com.tenlionsoft.baselib.net.RetrofitClient
import kotlinx.coroutines.launch

class MineViewModel(val context: Context) : BaseViewModel() {
    private val retrofitClient = RetrofitClient.getInstance(context)
    private val baseApi = retrofitClient.create(BaseApi::class.java)
    val isUploadIconSuccess = MutableLiveData<Boolean>()


    fun doUploadImg(meta: ImageMeta) {
        viewModelScope.launch {
            showLoadDialog.value = true
            try {
                val responseBean = retrofitClient.makeApiCall {
                    val body = meta.file!!.toFileBody("image")
                    baseApi.doUploadImage(body)
                }
                if (responseBean.code == 200) {
                    //TODO 更新头像上传成功
                    //设置成功后刷新页面
                    isUploadIconSuccess.value = true
                    showLoadDialog.value = false
                } else {
                    isUploadIconSuccess.value = false
                    showLoadDialog.value = false
                }
            } catch (e: Exception) {
                e.printStackTrace()
                isUploadIconSuccess.value = false
                ExParse.parse(e)
            }

        }
    }
}